# Projets de démo Django

Chacun des répertoires ci-dessous peut être récupéré comme projet Django, à savoir :

- `advanced` : fonctions avancées (URL téléchargement)
- `authentication` : bouts de code pour gérer les utilisateurs
- `forms` : test des formulaires
- `orm` : projet d'interface utilisant des données en base
- `templating` : utilisation du langage de templates
- `translation` : traduction

Les répertoires contiennent un fichier `manage.py` et peuvent être lancés avec la commande habituelle :

```bash
python manage.py runserver
```

Vérifiez quand même les fichiers `urls.py` pour savoir quelles URLs sont disponibles pour chaque projet (l'un d'entre eux ne répond pas à l'URL http://127.0.0.1/ mais répond à d'autres URLs).

---

Les répertoires de projet peuvent être ouverts avec PyCharm (contiennent un répertoire `.idea`). Vous devrez peut-être créer un environnement virtuel pour ces projets. Pour cela :

- rendez-vous dans le menu `File` → `Settings`
- dans la catégorie `Project` → `Python Interpreter`, vérifiez que l'interpréteur est dans un répertoire relatif à votre projet, ou créez un nouvel interpréteur `virtualenv`.

Avant de pouvoir exécuter le projet, vous devez installer les dépendances présentes dans requirements.txt :

```{.bash .numberLines}
pip install -r requirements.txt
```
