from django.contrib import admin

from library.models import Book


@admin.register(Book)
class BookAdmin(admin.ModelAdmin):
    """
    Admin for books.

    """

    list_display = ["id", "name", "isbn", "genre", "year"]
    list_editable = ["year", "genre"]
    list_filter = ["genre"]
    list_per_page = 25
